package com.inca.npbusi.sales.bms_tr_fetch;

import com.inca.entity.client.pub.CompanyOnClient;
import com.inca.gsp.service.GSPHelper;
import com.inca.np.auth.ClientUserManager;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CToolbar;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.control.UserManager;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.gui.tbar.TButton;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.hov.bms_sa_selfpkaddress.Bms_sa_selfpkaddress_hov;
import com.inca.pubsrv.hov.bms_tr_pos_hov.Bms_tr_pos_hov;
import com.inca.pubsrv.wmsservice.WmsHelper;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JToolBar;

public class Bms_tr_fetch_master extends CMasterModel {
   public Bms_tr_fetch_master(CFrame var1, CMdeModel var2) {
      super(var1, "销退申请总单表", var2);
   }

   public String getTablename() {
      return "bms_tr_fetch_doc_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected String getOtherWheres() {
      return "entryid=" + ClientUserManager.getCurrentUser().getEntryid() + " and fetchtype = 2";
   }

   public String getHovOtherWheres(int var1, String var2) {
      String var3 = ClientUserManager.getCurrentUser().getEntryid();
      if (!var2.equals("storageopcode")) {
         String var4;
         if (var2.equals("agentopcode")) {
            if (!(var4 = this.getItemValue(var1, "companyid")).equals("") && var4 != null) {
               return " type=2 and companyid=" + var4 + " and (entryid is null or entryid=" + var3 + ")";
            }

            this.infoMessage("提示！", "请选择相关单位！");
            return " 1>2";
         }

         if (var2.equals("saleropcode")) {
            if (!(var4 = this.getItemValue(var1, "companyid")).equals("") && var4 != null) {
               return " customid = " + var4 + " and entryid=" + var3;
            }

            this.infoMessage("提示！", "请选择相关单位！");
            return " 1>2";
         }

         if (var2.equals("agentid")) {
            return " type=2 and (entryid is null or entryid=" + var3 + ")";
         }

         if (var2.equals("trposopcode")) {
            if ((var4 = this.getItemValue(var1, "companyid")) != null && !var4.equals("")) {
               return "tranpostype = 1 and companyid = " + var4;
            }

            this.infoMessage("提示", "请先录入来货单位！");
            return "1>2";
         }

         if ("companyopcode".equals(var2)) {
            return GSPHelper.getCustomOtherWheresOnHov(var3, "pub_customer_v", "customid", true, true);
         }
      }

      return super.getHovOtherWheres(var1, var2);
   }

   protected int on_new(int var1) {
      this.setItemValue(var1, "credate", NpbusiDBHelper.getSysdate());
      this.setItemValue(var1, "usestatus", "2");
      this.setItemValue(var1, "fetchtype", "2");
      this.setItemValue(var1, "comefrom", "4");
      this.setItemValue(var1, "inputmanid", ClientUserManager.getCurrentUser().getUserid());
      this.setItemValue(var1, "inputmanname", ClientUserManager.getCurrentUser().getUsername());
      this.setItemValue(var1, "entryid", ((Bms_tr_fetch_mde)this.mdemodel).getEntryid());
      this.setItemValue(var1, "entryname", ((Bms_tr_fetch_mde)this.mdemodel).getEntryname());
      return super.on_new(var1);
   }

   protected JPanel createSecondtoolbar() {
      CToolbar var1 = new CToolbar();
      JPanel var2;
      (var2 = new JPanel()).setLayout(new BorderLayout());
      var1.add(this.a("选择原销售单生成明细(G)", "选择原销售单生成明细", "选择原销售单生成明细", 71));
      var1.add(new JToolBar.Separator());
      var1.add(new JToolBar.Separator());
      var1.add(new JToolBar.Separator());
      var1.add(new JToolBar.Separator());
      var1.add(new JToolBar.Separator());
      var1.add(new JToolBar.Separator());
      var1.add(this.a("确定(C)", "确定", "确定", 67));
      var1.add(new JToolBar.Separator());
      var1.add(new JToolBar.Separator());
      var1.add(this.a("回退确定(B)", "回退确定", "回退确定", 66));
      var1.add(new JToolBar.Separator());
      var1.add(new JToolBar.Separator());
      var1.add(this.a("中止(T)", "中止", "中止", 84));
      var1.add(new JToolBar.Separator());
      var1.add(new JToolBar.Separator());
      var1.add(this.a("作废(I)", "作废", "作废", 73));
      var1.add(new JToolBar.Separator());
      var1.add(new JToolBar.Separator());
      if (WmsHelper.checkConfig(UserManager.getCurrentUser().getEntryid())) {
         var1.add(this.a("下传物流通知(R)", "下传物流通知", "下传物流通知", 82));
         var1.add(new JToolBar.Separator());
         var1.add(new JToolBar.Separator());
      }

      var1.setBackground(var1.getComponent(0).getBackground());
      var2.add(var1);
      return var2;
   }

   private TButton a(String var1, String var2, String var3, int var4) {
      TButton var5;
      (var5 = new TButton(var1)).setToolTipText(var2);
      var5.setActionCommand(var3);
      var5.addActionListener(this.mdemodel);
      var5.setMnemonic(var4);
      var5.setFocusable(false);
      return var5;
   }

   public int on_hov(int var1, String var2, DBTableModel var3) {
      String var4 = ((Bms_tr_fetch_mde)this.mdemodel).getEntryid();
      if (var2.equals("companyopcode")) {
         if (!this.a(var3)) {
            return 0;
         }

         String var5;
         if ((var5 = this.getItemValue(var1, "agentid")) != null && var5.length() > 0) {
            this.setItemValue(var1, "agentid", "");
            this.setItemValue(var1, "agentopcode", "");
            this.setItemValue(var1, "agentname", "");
         }

         if ((var5 = var3.getItemValue(0, "customid")) == null || var5.equals("")) {
            return -1;
         }

         RemotesqlHelper var7 = new RemotesqlHelper();
         DBTableModel var8 = null;
         String var6 = "select * from zx_pub_custom_to_saler_v where customid=" + var5 + " and entryid=" + var4;

         try {
            var8 = var7.doSelect(var6, 0, 10);
         } catch (Exception var15) {
            var15.printStackTrace();
         }

         if (var8 == null || var8.getRowCount() <= 0) {
            this.infoMessage("提示", "没有业务员，不可录入总单！");
            this.setItemValue(var1, "customopcode", "");
            this.setItemValue(var1, "customid", "");
            this.setItemValue(var1, "saleropcode", "");
            this.setItemValue(var1, "salesdeptname", "");
            this.setItemValue(var1, "salerid", "");
            this.setItemValue(var1, "salesdeptid", "");
            this.setItemValue(var1, "salername", "");
            this.setItemValue(var1, "customname", "");
            return -1;
         }

         String var10;
         String var11;
         String var12;
         String var17;
         DBTableModel var19;
         if (var8.getRowCount() != 1) {
            Zx_pub_custom_to_saler_hov var18;
            (var18 = new Zx_pub_custom_to_saler_hov(true)).setOtherwheres("customid = " + var5 + " and entryid=" + var4);
            if ((var19 = var18.showDialog(this.frame, "")) == null) {
               this.setItemValue(var1, "salerid", "");
               this.setItemValue(var1, "saleropcode", "");
               this.setItemValue(var1, "salername", "");
               this.setItemValue(var1, "salesdeptname", "");
               this.setItemValue(var1, "salesdeptid", "");
            } else {
               var10 = var19.getItemValue(0, "salerid");
               var11 = var19.getItemValue(0, "saleropcode");
               var12 = var19.getItemValue(0, "salername");
               var6 = var19.getItemValue(0, "salerdeptname");
               var17 = var19.getItemValue(0, "salerdeptid");
               this.setItemValue(var1, "salerid", var10);
               this.setItemValue(var1, "saleropcode", var11);
               this.setItemValue(var1, "salername", var12);
               this.setItemValue(var1, "salesdeptname", var6);
               this.setItemValue(var1, "salesdeptid", var17);
            }
         } else {
            var6 = var8.getItemValue(0, "salerdeptid");
            String var9 = var8.getItemValue(0, "salerid");
            var10 = var8.getItemValue(0, "saleropcode");
            var11 = var8.getItemValue(0, "salername");
            var12 = var8.getItemValue(0, "salerdeptname");
            if (var6 == null || "".equals(var6)) {
               var6 = "select * from pub_employee_v where employeeid=" + var9;

               try {
                  var8 = var7.doSelect(var6, 0, 1);
               } catch (Exception var14) {
                  var14.printStackTrace();
               }

               var6 = var8.getItemValue(0, "deptid");
               var12 = var8.getItemValue(0, "deptname");
            }

            this.setItemValue(var1, "salerid", var9);
            this.setItemValue(var1, "saleropcode", var10);
            this.setItemValue(var1, "salername", var11);
            this.setItemValue(var1, "salesdeptname", var12);
            this.setItemValue(var1, "salesdeptid", var6);
         }

         var6 = "1";
         if ((var19 = NpbusiDBHelper.getCustomDefinfo(var4, var5)) != null && var19.getRowCount() > 0) {
            var6 = var19.getItemValue(0, "delivermethod");
            var10 = var19.getItemValue(0, "settletypeid");
            var11 = var19.getItemValue(0, "lowpriceflag");
            this.setItemValue(var1, "settletypeid", var10);
            this.setItemValue(var1, "delivermethod", var6);
            this.setItemValue(var1, "lowpriceflag", var11);
         } else {
            this.setItemValue(var1, "delivermethod", var6);
         }

         DBColumnDisplayInfo var21 = this.getDBColumnDisplayInfo("midposopcode");
         DBColumnDisplayInfo var22 = this.getDBColumnDisplayInfo("trposopcode");
         if (var6 != null && var6.equals("1")) {
            try {
               var8 = NpbusiDBHelper.getTranposinfo(var5);
            } catch (Exception var13) {
               var13.printStackTrace();
               this.infoMessage("提示", "查询客户的地址信息定义时出错:" + var13.getMessage());
               return -1;
            }

            int var23 = 0;
            if (var8 != null) {
               var23 = var8.getRowCount();
            }

            var6 = "";
            var17 = "";
            var4 = "";
            if (var23 == 1) {
               var6 = var8.getItemValue(0, "tranposid");
               var17 = var8.getItemValue(0, "tranposname");
               var4 = var8.getItemValue(0, "opcode");
            } else if (var23 != 0) {
               Bms_tr_pos_hov var20;
               (var20 = new Bms_tr_pos_hov(true)).setOtherwheres("COMPANYID = " + var5);
               DBTableModel var16;
               if ((var16 = var20.showDialog(this.frame, "")).getRowCount() > 0) {
                  var6 = var16.getItemValue(0, "tranposid");
                  var17 = var16.getItemValue(0, "tranposname");
                  var4 = var16.getItemValue(0, "opcode");
               }
            }

            this.setItemValue(var1, "trposid", var6);
            this.setItemValue(var1, "tranposname", var17);
            this.setItemValue(var1, "trposopcode", var4);
            this.setItemValue(var1, "midposid", "");
            this.setItemValue(var1, "midposname", "");
            this.setItemValue(var1, "midposopcode", "");
            var21.setReadonly(true);
            var22.setReadonly(false);
         } else if (var6 != null && var6.equals("0")) {
            this.on_itemvaluechange(var1, "delivermethod", var6);
         }
      }

      return super.on_hov(var1, var2, var3);
   }

   private boolean a(DBTableModel var1) {
      CompanyOnClient var3;
      (var3 = new CompanyOnClient(var1.getItemValue(0, "customid"))).setCompanyType(2);

      try {
         return var3.sendNomalCheck("4", ((Bms_tr_fetch_mde)this.mdemodel).getEntryid());
      } catch (Exception var2) {
         this.errorMessage("检查供应商执照错误", var2.getMessage());
         return false;
      }
   }

   protected int on_beforedel(int var1) {
      String var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "usestatus");
      if (!"2".equals(var2)) {
         this.warnMessage("警告", "非临时状态单据不能删除，只能作废！");
         return -1;
      } else {
         return super.on_beforedel(var1);
      }
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      if (var2.equals("companyid")) {
         if (!this.getItemValue(var1, "agentid").equals("")) {
            this.setItemValue(var1, "agentid", "");
            this.setItemValue(var1, "agentopcode", "");
            this.setItemValue(var1, "agentname", "");
         }
      } else if (var2.equals("delivermethod")) {
         DBColumnDisplayInfo var4 = this.getDBColumnDisplayInfo("midposopcode");
         DBColumnDisplayInfo var5 = this.getDBColumnDisplayInfo("trposopcode");
         String var7;
         String var8;
         String var9;
         DBTableModel var13;
         if ("0".equals(var3)) {
            var4.setReadonly(false);
            var5.setReadonly(true);
            this.setItemValue(var1, "trposopcode", "");
            this.setItemValue(var1, "trposid", "");
            this.setItemValue(var1, "tranposname", "");
            String var12 = "select addressid,addressname,addressopcode,defaultflag from selfpick_address where usestatus=1 order by nvl(defaultflag,0) desc";
            RemotesqlHelper var14 = new RemotesqlHelper();
            var7 = null;
            var8 = null;
            var9 = null;

            try {
               DBTableModel var6;
               if ((var6 = var14.doSelect(var12, 0, 100)) != null && var6.getRowCount() > 0) {
                  var12 = var6.getItemValue(0, "defaultflag");
                  if (!"1".equals(var12) && var6.getRowCount() != 1) {
                     if ((var13 = (new Bms_sa_selfpkaddress_hov(true)).showDialog(this.frame, "")).getRowCount() > 0) {
                        var7 = var13.getItemValue(0, "addressid");
                        var9 = var13.getItemValue(0, "addressname");
                        var8 = var13.getItemValue(0, "addressopcode");
                     }
                  } else {
                     var7 = var6.getItemValue(0, "addressid");
                     var9 = var6.getItemValue(0, "addressname");
                     var8 = var6.getItemValue(0, "addressopcode");
                  }

                  this.setItemValue(var1, "midposid", var7);
                  this.setItemValue(var1, "midposname", var9);
                  this.setItemValue(var1, "midposopcode", var8);
               }
            } catch (Exception var11) {
               var11.printStackTrace();
            }
         } else if ("1".equals(var3)) {
            var4.setReadonly(true);
            var5.setReadonly(false);
            this.setItemValue(var1, "midposopcode", "");
            this.setItemValue(var1, "midposid", "");
            this.setItemValue(var1, "midposname", "");
            String var15 = this.getItemValue(var1, "companyid");

            try {
               var13 = NpbusiDBHelper.getTranposinfo(var15);
            } catch (Exception var10) {
               var10.printStackTrace();
               this.infoMessage("提示", "查询客户的地址信息定义时出错:" + var10.getMessage());
               return;
            }

            int var17 = 0;
            if (var13 != null) {
               var17 = var13.getRowCount();
            }

            var7 = "";
            var8 = "";
            var9 = "";
            if (var17 == 1) {
               var7 = var13.getItemValue(0, "tranposid");
               var8 = var13.getItemValue(0, "tranposname");
               var9 = var13.getItemValue(0, "opcode");
            } else if (var17 != 0) {
               Bms_tr_pos_hov var16;
               (var16 = new Bms_tr_pos_hov(true)).setOtherwheres("COMPANYID = " + var15);
               if ((var13 = var16.showDialog(this.frame, "")).getRowCount() > 0) {
                  var7 = var13.getItemValue(0, "tranposid");
                  var8 = var13.getItemValue(0, "tranposname");
                  var9 = var13.getItemValue(0, "opcode");
               }
            }

            if (var3 != null && var3.equals("1")) {
               this.setItemValue(var1, "trposid", var7);
               this.setItemValue(var1, "tranposname", var8);
               this.setItemValue(var1, "trposopcode", var9);
            }
         } else {
            this.setItemValue(var1, "midposopcode", "");
            this.setItemValue(var1, "trposopcode", "");
         }
      }

      super.on_itemvaluechange(var1, var2, var3);
   }

   protected String getEditablecolumns(int var1) {
      String var2;
      if ((var2 = this.getItemValue(var1, "wfusestatus")) != null && !var2.equals("")) {
         return "nothing";
      } else {
         String var3;
         if ((var3 = this.getItemValue(var1, "usestatus")) != null && !var3.equals("2")) {
            return "nothing";
         } else {
            return this.mdemodel.getDetailModel().getRowCount() > 0 ? "memo" : "credate,fetchno,companyopcode,agentopcode,saleropcode,memo,trposopcode,midposopcode,delivermethod,nowmsflag,storageopcode";
         }
      }
   }
}
